Bug 590499 - pl-jpl : jpl.jar unable to find and load JNI library libjpl.so
pl-jpl : jpl.jar unable to find and load JNI library libjpl.so
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: pl (Show other bugs)
15
All Linux
low Severity medium
: ---
: ---
Assigned To: Petr Pisar
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-09 18:45 EDT by Mohamed El Morabity
Modified: 2012-03-20 22:37 EDT (History)
3 users (show)

See Also:
Fixed In Version: pl-5.10.2-8.fc16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-03-13 14:41:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Mohamed El Morabity 2010-05-09 18:45:25 EDT
Description of problem:
When launching a Java program using jpl.jar, the following exception occurs:
   java.lang.UnsatisfiedLinkError: no jpl in java.library.path


How reproducible:
Compile the Java example file given in /usr/share/doc/pl-jpl-5.7.11/examples/java/Family/:
  $ cp -r /usr/share/doc/pl-jpl-5.7.11/examples/java/Family/ .
  $ javac -classpath /usr/lib64/pl-jpl/jpl.jar Family.java
  $ java -classpath /usr/lib64/pl-jpl/jpl.jar:. Family
  
Actual results:
An exception occurs:
   Exception in thread "main" java.lang.UnsatisfiedLinkError: no jpl in java.library.path
	at java.lang.ClassLoader.loadLibrary(ClassLoader.java:1678)
	at java.lang.Runtime.loadLibrary0(Runtime.java:840)
	at java.lang.System.loadLibrary(System.java:1047)
	at jpl.JPL.loadNativeLibrary(JPL.java:100)
	at jpl.fli.Prolog.<clinit>(Prolog.java:85)
	at jpl.Query.open(Query.java:286)
	at jpl.Util.textToTerm(Util.java:162)
	at jpl.Query.<init>(Query.java:198)
	at Family.main(Family.java:12)

Expected results:
   libjpl.so should be found and loaded.

Additional info:
Running the class with -Djava.library.path=/usr/lib64/pl-jpl/ is obviously the solution, but the library should be loaded without any intervention :-).
Moreover Java packaging guidelines say that:
  " If the JNI-using code calls System.loadLibrary you'll have to patch it to use System.load, passing it the full path to the dynamic shared object."
whereas it doesn't seem to be the case (no appropriate patch in the pl source package, see also in the source the src/java/jpl/JPL.java file).
Comment 1 Bug Zapper 2010-11-03 11:14:00 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Fedora Admin XMLRPC Client 2010-11-18 08:46:38 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 3 Bug Zapper 2010-12-03 09:53:01 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Petr Pisar 2010-12-03 10:04:27 EST
Still presents in F14.
Comment 5 Bug Zapper 2011-06-02 10:17:42 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2011-06-27 12:12:58 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 7 Petr Pisar 2012-03-08 08:42:04 EST
I'm sorry this has not been fixed in F14. Please use currently supported Fedora release. This issue should be fixed since Fedora 15.
Comment 8 Petr Pisar 2012-03-08 08:45:07 EST
Oops. I wanted to close different bug report.

This issue will be fixed soon.
Comment 9 Petr Pisar 2012-03-08 11:13:11 EST
Fixed as pl-6.0.2-1.fc18 in F18.
Comment 10 Fedora Update System 2012-03-08 11:17:53 EST
pl-6.0.2-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/pl-6.0.2-1.fc17
Comment 11 Fedora Update System 2012-03-08 20:07:24 EST
Package pl-6.0.2-1.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing pl-6.0.2-1.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-3447/pl-6.0.2-1.fc17
then log in and leave karma (feedback).
Comment 12 Mohamed El Morabity 2012-03-08 20:30:08 EST
Thanks for the fix. It seems OK on F17 :)
Comment 13 Petr Pisar 2012-03-09 05:00:09 EST
I packaged the jpl.jar symlink twice by accident. This is fixed in  pl-6.0.2-2.fc17.
Comment 14 Fedora Update System 2012-03-09 05:02:53 EST
pl-5.10.2-8.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/pl-5.10.2-8.fc16
Comment 15 Fedora Update System 2012-03-09 05:03:26 EST
pl-5.10.2-7.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/pl-5.10.2-7.fc15
Comment 16 Fedora Update System 2012-03-09 12:56:25 EST
Package pl-6.0.2-2.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing pl-6.0.2-2.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-3447/pl-6.0.2-2.fc17
then log in and leave karma (feedback).
Comment 17 Fedora Update System 2012-03-13 14:41:22 EDT
pl-6.0.2-2.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 18 Fedora Update System 2012-03-20 22:30:02 EDT
pl-5.10.2-7.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2012-03-20 22:37:08 EDT
pl-5.10.2-8.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.